<template>
  <q-layout view="lHh Lpr lFf">
    <q-header elevated>
      <q-toolbar>
        <q-btn flat dense round icon="menu" aria-label="Menu" @click="leftDrawerOpen = !leftDrawerOpen" />

        <q-toolbar-title>
          World of Facts
        </q-toolbar-title>

        <div v-if="showNewFactBtn" class="q-mr-md">
          <q-btn label="+ Add New Fact" color="positive" class="q-m-md" @click="openDialog" />
        </div>

        <div>A place to learn a little bit about a lot</div>
      </q-toolbar>
    </q-header>

    <q-drawer v-model="leftDrawerOpen" show-if-above bordered>
      <q-list>
        <q-item-label header>
          I Want To Learn About...
        </q-item-label>

        <NavLink v-for="link in navLinks" :key="link.title" :link="link" />
      </q-list>
    </q-drawer>

    <q-page-container>
      <router-view v-slot="{ Component }">
        <component ref="view" :is="Component" />
      </router-view>
    </q-page-container>
  </q-layout>
</template>

<script lang="ts" setup>
import { ref, watch } from 'vue'
import { useRoute } from 'vue-router'
import NavLink from 'components/NavLink.vue'

const route = useRoute()

const routes = ['CatsIndex', 'DogsIndex']
const showNewFactBtn = ref(routes.includes(route.name as string))

watch(() => route.name, () => {
  showNewFactBtn.value = routes.includes(route.name as string)
})

const leftDrawerOpen = ref(true)
const view = ref()

function openDialog () {
  view.value.openDialog()
}

const navLinks = [
  {
    title: 'Cats',
    caption: 'A collection of facts about cats',
    icon: 'pets',
    route: { name: 'CatsIndex' }
  },
  {
    title: 'Dogs',
    caption: 'A collection of facts about dogs',
    icon: 'pets',
    route: { name: 'DogsIndex' }
  }
]
</script>
